@echo off

rem getting input parameters
set TEMP_FILE=%1
set DSN_NAME=%2
set USER=%3
set PASS=%4
set DB2_SCHEMA=%5
REM set PROPS_FILE=%6
for %%A in (%*) do set PROPS_FILE=%%A
set ACTUATOR_LOG="..\log\%PROPS_FILE%.log"
rem end

mkdir %PROPS_FILE%.dir
rem checking input parameters
if %TEMP_FILE%=="" (
 echo %date% %time% FAILURE. Sublog name is not defined. > %ACTUATOR_LOG%
 exit /b 1
)

if %DSN_NAME%=="" (
 echo %date% %time% FAILURE. DSN name is not defined. > %ACTUATOR_LOG%
 exit /b 1
)

if %DB2_SCHEMA%=="" (
 echo %date% %time% FAILURE. DB2 schema is not defined. > %ACTUATOR_LOG%
 exit /b 1
)

if %USER%=="" (
 echo %date% %time% FAILURE. User name is not defined. > %ACTUATOR_LOG%
 exit /b 1
)

if %PASS%=="" (
 echo %date% %time% FAILURE. Password is not defined. > %ACTUATOR_LOG%
 exit /b 1
)

if %PROPS_FILE%=="" (
 echo %date% %time% FAILURE. PROPSFILE is not defined. > %ACTUATOR_LOG%
 exit /b 1
)
rem removing actuator log in order to create new
echo %date% %time% Processing started. > %ACTUATOR_LOG%



rem for ame 2.1
echo %date% %time% Trying to collect the data from DB2 AME 2.1.>> %ACTUATOR_LOG%
echo "SELECT adhevent.tuid, adhevent.action_tuid, adhevent.target_tuid, adhevent.user_tuid, adhevent.time, adhevent.result, adhevent.source_tuid, adhevent.detail_tuid, adhevent.corr_id, adhevent.source_detail_tuid, adhevent.authchange_tuid, adhevent_action.agent_id,  adhevent_action.category,  adhevent_action.event_type,  adhevent_action.context_type, adhevent_user.user_id, adhevent_user.authorization_id, adhevent_user.original_op_id, adhevent_user.account_token, adhevent_user.end_user_id, adhevent_user.end_usr_trans_name, adhevent_user.end_usr_wkstn_name, adhevent_target.container, adhevent_target.xschema, adhevent_target.name, adhevent_target.type, adhevent_target.new_sqlid,  adhevent_target.database_id, adhevent_src.xdatabase,  adhevent_src.app_id,  adhevent_src.app_name,  adhevent_src.origin_node_num,  adhevent_src.corr_node_num,  adhevent_src.db2_subsystem_id,  adhevent_src.location,  adhevent_src.network_id, adhevent_src.luname,  adhevent_src.corr_id,  adhevent_src.connection_name,  adhevent_src.system_con_type,  adhevent_src.requestor_location,  adhevent_src.requestor_svr_name,  adhevent_src.requestor_prod_id,  adhevent_src.member_name,  adhevent_src.group_name, adhevent_src.current_sqlid, adhevent_dtail.approval_reason,  adhevent_dtail.access_attempted,  adhevent_dtail.grantor, adhevent_dtail.grantee, adhevent_dtail.grant_type,  adhevent_dtail.priv_auth,  adhevent_dtail.auth_type, adhevent_dtail.plugin_name, adhevent_dtail.utility_info, adhagent.name, adhagent.user_id, adhagent.system, adhagent.subsystem,  adhagent.port, adhagent.connect_type,  adhagent.session_id, adhevent.EV_SQLCA, adhevent.BEGIN_URID, adhevent.END_URID, adhevent.SQLCA_ROW_CT, adhevent.LRSN, adhevent.DATA_SOURCE, adhevent.TEXT_XREF_TUID, adhevent.HOSTVAR_GROUP_ID, adhevent.TIME_LOCAL, adhevent_src.END_USR_TRANS_NAME FROM %DB2_SCHEMA%.adhevent AS adhevent, %DB2_SCHEMA%.adhevent_action AS adhevent_action, %DB2_SCHEMA%.adhevent_user AS adhevent_user, %DB2_SCHEMA%.adhevent_target AS adhevent_target, %DB2_SCHEMA%.adhevent_src AS adhevent_src, %DB2_SCHEMA%.adhevent_dtail AS adhevent_dtail, %DB2_SCHEMA%.adhagent AS adhagent WHERE adhevent.action_tuid=adhevent_action.tuid AND adhevent.user_tuid=adhevent_user.tuid AND adhevent.target_tuid=adhevent_target.tuid AND adhevent.source_tuid=adhevent_src.tuid AND adhevent.detail_tuid=adhevent_dtail.tuid AND adhagent.tuid = adhevent_action.agent_id ORDER BY adhevent.time" > ..\run\%PROPS_FILE%.dir\%PROPS_FILE%.sql

call ..\bin\odbc-genact.exe -separator=";" -fromquery1 -id=tuid -props=%PROPS_FILE% -useheaderline %TEMP_FILE% "" "" "" %DSN_NAME% %USER% %PASS% "..\run\%PROPS_FILE%.dir\%PROPS_FILE%.sql" TIME >> %ACTUATOR_LOG%
if %ERRORLEVEL% NEQ 0 (
 echo %date% %time% Unable to collect the data from DB2 AME 2.1.>> %ACTUATOR_LOG%
 ) else (GOTO finish)

echo %date% %time% Trying to collect the data from DB2 AME 1.1.>> %ACTUATOR_LOG%
rem for ame 1.1
echo SELECT adhevent.tuid, adhevent.action_tuid, adhevent.target_tuid, adhevent.user_tuid, adhevent.time, adhevent.result, adhevent.source_tuid, adhevent.detail_tuid, adhevent.corr_id, adhevent.source_detail_tuid, adhevent.authchange_tuid, adhevent_action.agent_id,  adhevent_action.category,  adhevent_action.event_type,  adhevent_action.context_type, adhevent_user.user_id, adhevent_user.authorization_id, adhevent_user.original_op_id, adhevent_user.account_token, adhevent_user.end_user_id, adhevent_user.end_usr_trans_name, adhevent_user.end_usr_wkstn_name, adhevent_target.container, adhevent_target.xschema, adhevent_target.name, adhevent_target.type, adhevent_target.new_sqlid,  adhevent_target.database_id, adhevent_src.xdatabase,  adhevent_src.app_id,  adhevent_src.app_name,  adhevent_src.origin_node_num,  adhevent_src.corr_node_num,  adhevent_src.db2_subsystem_id,  adhevent_src.location,  adhevent_src.network_id, adhevent_src.luname,  adhevent_src.corr_id,  adhevent_src.connection_name,  adhevent_src.system_con_type,  adhevent_src.requestor_location,  adhevent_src.requestor_svr_name,  adhevent_src.requestor_prod_id,  adhevent_src.member_name,  adhevent_src.group_name, adhevent_src.current_sqlid, adhevent_dtail.approval_reason,  adhevent_dtail.access_attempted,  adhevent_dtail.grantor, adhevent_dtail.grantee, adhevent_dtail.grant_type,  adhevent_dtail.priv_auth,  adhevent_dtail.auth_type, adhevent_dtail.plugin_name, adhevent_dtail.utility_info, adhagent.name, adhagent.user_id, adhagent.system, adhagent.subsystem,  adhagent.port, adhagent.connect_type,  adhagent.session_id FROM %DB2_SCHEMA%.adhevent AS adhevent, %DB2_SCHEMA%.adhevent_action AS adhevent_action, %DB2_SCHEMA%.adhevent_user AS adhevent_user, %DB2_SCHEMA%.adhevent_target AS adhevent_target, %DB2_SCHEMA%.adhevent_src AS adhevent_src, %DB2_SCHEMA%.adhevent_dtail AS adhevent_dtail, %DB2_SCHEMA%.adhagent AS adhagent WHERE adhevent.action_tuid=adhevent_action.tuid AND adhevent.user_tuid=adhevent_user.tuid AND adhevent.target_tuid=adhevent_target.tuid AND adhevent.source_tuid=adhevent_src.tuid AND adhevent.detail_tuid=adhevent_dtail.tuid AND adhagent.tuid = adhevent_action.agent_id ORDER BY adhevent.time > ..\run\%PROPS_FILE%.dir\%PROPS_FILE%.sql
call ..\bin\odbc-genact.exe -separator=";" -fromquery1 -id=tuid -props=%PROPS_FILE% -useheaderline %TEMP_FILE% "" "" "" %DSN_NAME% %USER% %PASS% "..\run\%PROPS_FILE%.dir\%PROPS_FILE%.sql" TIME >> %ACTUATOR_LOG%
if %ERRORLEVEL% NEQ 0 (
 echo %date% %time% Unable to collect the data from DB2 AME 1.1.>> %ACTUATOR_LOG%
 echo %date% %time% FAILURE. Processing finished. >> %ACTUATOR_LOG%
 EXIT /b 1
        ) 
:finish
echo %date% %time% SUCCESS. Processing finished. >> %ACTUATOR_LOG%

rmdir %PROPS_FILE%.DIR /S /q
exit /b 0
