REM Licensed Materials - Property of IBM
REM 5724-S67
REM (c) Copyright IBM Corp. 1998, 2007   All Rights Reserved.
REM US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@echo off

rem getting input parameters
setlocal EnableDelayedExpansion


set TEMP_FILE=%1
set DOMAIN=%~6
set LDAP_CONFIG=%~7
shift
shift
shift
shift
set PROPS_FILE=%9

set ACTUATOR_LOG="..\log\%PROPS_FILE%.log"

rem checking parameters
if %TEMP_FILE%=="" (
 echo %date% %time% Output file is not defined. >> %ACTUATOR_LOG%
 exit /b 1
)

if %PROPS_FILE%=="" (
 echo %date% %time% PROPS_FILE is not defined. >> %ACTUATOR_LOG%
 exit /b 1
)

rem setting LDAP parameters
set /A LDAP_ENABLED=0
set LDAP_HOST=127.0.0.1
set LDAP_PORT=389
set USER_OBJECTCLASS=inetOrgPerson
set GROUP_OBJECTCLASS=groupOfNames
set USER_BASEDN=c=com
set GROUP_BASEDN=c=com
set USERID_ATTRIBUTE=uid
set AUTHID_ATTRIBUTE=uid
set GROUPNAME_ATTRIBUTE=cn
set SEARCH_DN=
set SEARCH_PW=
set GROUP_LOOKUP_METHOD=SEARCH_BY_DN
set GROUP_LOOKUP_ATTRIBUTE=member


echo %date% %time% Processing started. > %ACTUATOR_LOG%


if "%DOMAIN%"=="" (goto LDAP)

goto OS

rem parsing LDAP_CONFIG for actual values

:LDAP

     if exist "%LDAP_CONFIG%" (
         echo %date% %time% Collecting LDAP users and groups. >> %ACTUATOR_LOG%
         for /F "eol=; delims== tokens=1,*" %%i in ('type "%LDAP_CONFIG%"') do (
             rem echo -"%%i"- -"%%j"-
             for /F %%x in ("%%i") do ( set A=%%~x)
             for /F %%x in ("%%j") do ( set B=%%~x)
             if "!A!"=="LDAP_HOST" set LDAP_HOST=!B!
             if "!A!"=="USER_OBJECTCLASS" set USER_OBJECTCLASS=!B!
             if "!A!"=="GROUP_OBJECTCLASS" set GROUP_OBJECTCLASS=!B!
             if "!A!"=="AUTHID_ATTRIBUTE" set AUTHID_ATTRIBUTE=!B!
             if "!A!"=="GROUPNAME_ATTRIBUTE" set GROUPNAME_ATTRIBUTE=!B!
             if "!A!"=="GROUP_LOOKUP_METHOD" set GROUP_LOOKUP_METHOD=!B!
             if "!A!"=="GROUP_LOOKUP_ATTRIBUTE" set GROUP_LOOKUP_ATTRIBUTE=!B!
             if "!A!"=="SEARCH_PW" set SEARCH_PW=!B!
             if "!A!"=="USER_BASEDN" set USER_BASEDN=%%j
             if "!A!"=="GROUP_BASEDN" set GROUP_BASEDN=%%j
             if "!A!"=="SEARCH_DN" set SEARCH_DN=%%j
             
             for /F "delims=: tokens=1,2" %%x in ("!LDAP_HOST!") do (
                 if %%y GTR . ( 
                     set LDAP_PORT=%%y
                     set LDAP_HOST=%%x
                    )                        
                )     
            )
        ) else ( 
                  echo %date% %time% LDAP config file does not exist. >> %ACTUATOR_LOG%
                  echo %date% %time% Processing finished ^(FAILURE^). >> %ACTUATOR_LOG%
                  endlocal
                  exit /b 1
                )
    
for /F "tokens=* delims= " %%a in ("%LDAP_HOST%") do set LDAP_HOST=%%a
for /l %%a in (1,1,100) do if "!LDAP_HOST:~-1!"==" " set LDAP_HOST=!LDAP_HOST:~0,-1!
for /F "tokens=* delims= " %%a in ("%LDAP_PORT%") do set LDAP_PORT=%%a
for /l %%a in (1,1,100) do if "!LDAP_PORT:~-1!"==" " set LDAP_PORT=!LDAP_PORT:~0,-1!
for /F "tokens=* delims= " %%a in ("%USER_OBJECTCLASS%") do set USER_OBJECTCLASS=%%a
for /l %%a in (1,1,100) do if "!USER_OBJECTCLASS:~-1!"==" " set USER_OBJECTCLASS=!USER_OBJECTCLASS:~0,-1!
for /F "tokens=* delims= " %%a in ("%GROUP_OBJECTCLASS%") do set GROUP_OBJECTCLASS=%%a
for /l %%a in (1,1,100) do if "!GROUP_OBJECTCLASS:~-1!"==" " set GROUP_OBJECTCLASS=!GROUP_OBJECTCLASS:~0,-1!
for /F "tokens=* delims= " %%a in ("%AUTHID_ATTRIBUTE%") do set AUTHID_ATTRIBUTE=%%a
for /l %%a in (1,1,100) do if "!AUTHID_ATTRIBUTE:~-1!"==" " set AUTHID_ATTRIBUTE=!AUTHID_ATTRIBUTE:~0,-1!
for /F "tokens=* delims= " %%a in ("%GROUPNAME_ATTRIBUTE%") do set GROUPNAME_ATTRIBUTE=%%a
for /l %%a in (1,1,100) do if "!GROUPNAME_ATTRIBUTE:~-1!"==" " set GROUPNAME_ATTRIBUTE=!GROUPNAME_ATTRIBUTE:~0,-1!
for /F "tokens=* delims= " %%a in ("%GROUP_LOOKUP_METHOD%") do set GROUP_LOOKUP_METHOD=%%a
for /l %%a in (1,1,100) do if "!GROUP_LOOKUP_METHOD:~-1!"==" " set GROUP_LOOKUP_METHOD=!GROUP_LOOKUP_METHOD:~0,-1!
for /F "tokens=* delims= " %%a in ("%GROUP_LOOKUP_ATTRIBUTE%") do set GROUP_LOOKUP_ATTRIBUTE=%%a
for /l %%a in (1,1,100) do if "!GROUP_LOOKUP_ATTRIBUTE:~-1!"==" " set GROUP_LOOKUP_ATTRIBUTE=!GROUP_LOOKUP_ATTRIBUTE:~0,-1!
for /F "tokens=* delims= " %%a in ("%SEARCH_PW%") do set SEARCH_PW=%%a
for /l %%a in (1,1,100) do if "!SEARCH_PW:~-1!"==" " set SEARCH_PW=!SEARCH_PW:~0,-1!
for /F "tokens=* delims= " %%a in ("%USER_BASEDN%") do set USER_BASEDN=%%a
for /l %%a in (1,1,100) do if "!USER_BASEDN:~-1!"==" " set USER_BASEDN=!USER_BASEDN:~0,-1!
for /F "tokens=* delims= " %%a in ("%GROUP_BASEDN%") do set GROUP_BASEDN=%%a
for /l %%a in (1,1,100) do if "!GROUP_BASEDN:~-1!"==" " set GROUP_BASEDN=!GROUP_BASEDN:~0,-1!
for /F "tokens=* delims= " %%a in ("%SEARCH_DN%") do set SEARCH_DN=%%a
for /l %%a in (1,1,100) do if "!SEARCH_DN:~-1!"==" " set SEARCH_DN=!SEARCH_DN:~0,-1!


java -classpath "..\bin\getViper2ldapgroups.jar" nl.consul.cea.gensub.db2viper.java.CollectViperGroups -LDAPHost?"!LDAP_HOST!" -LDAPPort?"!LDAP_PORT!" -UserName?"!SEARCH_DN!" -Password?"!SEARCH_PW!" -USER_BASEDN?"!USER_BASEDN!" -AUTHID_ATTRIBUTE?"!AUTHID_ATTRIBUTE!" -USER_OBJECTCLASS?"!USER_OBJECTCLASS!" -GROUP_OBJECTCLASS?"!GROUP_OBJECTCLASS!" -GROUP_BASEDN?"!GROUP_BASEDN!" -GROUPNAME_ATTRIBUTE?"!GROUPNAME_ATTRIBUTE!" -GROUP_LOOKUP_METHOD?"!GROUP_LOOKUP_METHOD!" -GROUP_LOOKUP_ATTRIBUTE?"!GROUP_LOOKUP_ATTRIBUTE!" -Filename?"%TEMP_FILE%" 2>>%ACTUATOR_LOG%
if %ERRORLEVEL% NEQ 0 (
     echo %date% %time% Unable to collect LDAP users.>> %ACTUATOR_LOG%
     echo %date% %time% Processing finished ^(FAILURE^). >> %ACTUATOR_LOG%
     endlocal      
     exit /b 1
     ) else ( echo %date% %time% End collecting LDAP users and groups.>> %ACTUATOR_LOG% )
        
goto FINISH
      
   
:OS   
echo %date% %time% Collecting OS groups and users. >> %ACTUATOR_LOG%


call ..\bin\getgroups.bat %TEMP_FILE% "" "" "" "" %DOMAIN% "" "" "" "" "" "" %PROPS_FILE%
if %ERRORLEVEL% NEQ 0 (
     echo %date% %time% Unable to collect OS groups and users.>> %ACTUATOR_LOG%
     echo %date% %time% Processing finished ^(FAILURE^). >> %ACTUATOR_LOG%
     endlocal
     exit /b 1
     )


rem grouping file is ready here

:FINISH
rem used for successfull exit.
echo %date% %time% Collect of user and group information is successful. >> %ACTUATOR_LOG%
echo %date% %time% Processing finished ^(SUCCESS^). >> %ACTUATOR_LOG%
endlocal
exit /b 0