@echo off

setlocal
rem ----- Receive parameters from the InSight actuator
set temp_file1=%1
set temp_file2=%2
set temp_file3=%3
set temp_file4=%4
set temp_file5=%5
set temp_file6=%6
set db2_folder=%~7
set instance_name=%~8
set UserName=%9
shift
set Password=%9
shift
set Truncate=%9
shift
set Context=%9
for %%A in (%*) do set props_file=%%A

rem ----- Create actuator progress log file
rem if not exist ..\log mkdir ..\log
set LOG_FILE="..\log\%props_file%.log"
type nul > %LOG_FILE%
echo [%date%][%time%] Start processing >> %LOG_FILE%

if %temp_file1% EQU "" (
    echo [%date%][%time%] Failure: Missing argument TEMPFILE1 >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
)

if %temp_file2% EQU "" (
    echo [%date%][%time%] Failure: Missing argument TEMPFILE2 >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
)
if %temp_file3% EQU "" (
    echo [%date%][%time%] Failure: Missing argument TEMPFILE3 >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
)
if %temp_file4% EQU "" (
    echo [%date%][%time%] Failure: Missing argument TEMPFILE4 >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
)
if %temp_file5% EQU "" (
    echo [%date%][%time%] Failure: Missing argument TEMPFILE5 >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
)
if %temp_file6% EQU "" (
    echo [%date%][%time%] Failure: Missing argument TEMPFILE6 >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
)
if "%db2_folder%" EQU "" (
    echo [%date%][%time%] Failure: Missing argument DB2 FOLDER >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
)
if "%instance_name%" EQU "" (
    echo [%date%][%time%] Failure: Missing argument INSTANCE_NAME >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
)
if %props_file% EQU "" (
    echo [%date%][%time%] Failure: Missing argument PROPS_FILE >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
)

rem ----- Set DB2INSTANCE environment variable to %instance_name% value
set db2instance=%instance_name%

rem ----- Set %db2_log_path% variable to "%db2_folder%\%instance_name%\security" value
set db2_log_path="%db2_folder%\%instance_name%\security"

rem ----- QE0807002: Take 'LastPruneTime' from propsfile
if EXIST "%props_file%" (
    for /F "delims=" %%I in ('findstr /R "^[0-9][0-9]*$" "%props_file%"') DO (set LastPruneTime=%%I)
)
echo LastPruneTime: %LastPruneTime% >> %LOG_FILE%

for /F "delims=" %%I IN ('..\bin\date.exe +%%Y%%m%%d%%H') DO (set CurrentTime=%%I)
rem ---- END QE0807002
rem ----- If the following files %db2_log_path%\*.del exist then remove them.
rem ----- If failed then finish work with return code 3
if exist %db2_log_path%\*.del (
    del /q /f %db2_log_path%\*.del
    if exist %db2_log_path%\*.del (
        echo [%date%][%time%] Failure: error removing %db2_log_path%\*.del files >> %LOG_FILE%
        echo [%date%][%time%] Processing finished [FAILURE 3] >> %LOG_FILE%
        exit /b 3
    ) else (
        echo [%date%][%time%] Old "*.del" files in %instance_name% instance were removed successfully >> %LOG_FILE%
    )
)

rem ----- Run "%db2_folder%\bin\db2audit.exe flush" command

if %UserName%=="" (
    "%db2_folder%\bin\db2audit.exe" flush
) else (
    ..\bin\psexec \\127.0.0.1 -u %UserName% -p %Password% "%db2_folder%\bin\db2audit.exe" flush >> %LOG_FILE%
)

if errorlevel 1 (
    echo [%date%][%time%] Failure: "%db2_folder%\bin\db2audit.exe flush" command execution failure >> %LOG_FILE%
    echo [%date%][%time%] Check DB2 8.1 - 9.1 event source credentials >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
) else (
    echo [%date%][%time%] "db2audit flush" operation succeeded >> %LOG_FILE%
)

rem ----- Run "%db2_folder%\bin\db2audit.exe extract delasc category audit, checking, secmaint, sysadmin, validate" command
if %UserName% == "" (
    "%db2_folder%\bin\db2audit.exe" extract delasc category audit, checking, secmaint, sysadmin, validate, context
) else (
    ..\bin\psexec \\127.0.0.1 -u %UserName% -p %Password% "%db2_folder%\bin\db2audit.exe" extract delasc category audit, checking, secmaint, sysadmin, validate, context >> %LOG_FILE%
)

if errorlevel 1 (
    echo [%date%][%time%] Failure: "%db2_folder%\bin\db2audit.exe extract delasc" command execution failure >> %LOG_FILE%
    echo [%date%][%time%] Check DB2 8.1 - 9.1 event source credentials >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 1] >> %LOG_FILE%
    exit /b 1
) else (
    echo [%date%][%time%] "db2audit extract delasc" operation succeeded >> %LOG_FILE%
)


rem ----- QE0807002: If option "truncate" is set to 'yes' - get rid of the events we've already collected by prunning all records up to YYYYMMDDHH time in db2audit.log to resolve problem with high cpu 
rem ----- and memory usage.

if "%Truncate%" EQU "yes" (
    echo [%date%][%time%] Truncate requested, prunning >> %LOG_FILE%
    echo [%date%][%time%] Current time: %CurrentTime% LastPruneTime: %LastPruneTime% >> %LOG_FILE%
    if "%CurrentTime%" GTR "%LastPruneTime%" (
        set LastPruneTime=%CurrentTime%
        echo [%date%][%time%] Prunning records up to %CurrentTime% >> %LOG_FILE%
        if %UserName%=="" (
            "%db2_folder%\bin\db2audit.exe" prune date %CurrentTime%
        ) else (
            ..\bin\psexec \\127.0.0.1 -u %UserName% -p %Password% "%db2_folder%\bin\db2audit.exe" prune date %CurrentTime% >> %LOG_FILE%
        )
    ) else (
        echo [%date%][%time%] Will not prune because all records are up to date >> %LOG_FILE%
    )
)
rem ----END QE0807002


rem ----- Set %none_log_access% variable to 1
set none_log_access=1

rem ----- Call getdb2recs.vbs script
rem ----- If the getdb2recs.vbs script return code 0, set %none_log_access% variable to 0
set executable=cscript.exe //B //NoLogo ..\bin\getdb2recs.vbs
call %executable% %db2_log_path% "audit.del" %temp_file1% %props_file%
if %errorlevel%==0 set none_log_access=0

set executable=cscript.exe //B //NoLogo ..\bin\getdb2recs.vbs
call %executable% %db2_log_path% "checking.del" %temp_file2% %props_file%
if %errorlevel%==0 set none_log_access=0

set executable=cscript.exe //B //NoLogo ..\bin\getdb2recs.vbs
call %executable% %db2_log_path% "secmaint.del" %temp_file3% %props_file%
if %errorlevel%==0 set none_log_access=0

set executable=cscript.exe //B //NoLogo ..\bin\getdb2recs.vbs
call %executable% %db2_log_path% "sysadmin.del" %temp_file4% %props_file%
if %errorlevel%==0 set none_log_access=0

set executable=cscript.exe //B //NoLogo ..\bin\getdb2recs.vbs
call %executable% %db2_log_path% "validate.del" %temp_file5% %props_file%
if %errorlevel%==0 set none_log_access=0

if "%Context%" EQU "on" (
    echo [%date%][%time%] Context processing "on" >> %LOG_FILE%
    set executable=cscript.exe //B //NoLogo ..\bin\getdb2recs.vbs
    call %executable% %db2_log_path% "context.del" %temp_file6% %props_file%
    if %errorlevel%==0 set none_log_access=0
    ) else (
        echo [%date%][%time%] Context processing "off" >> %LOG_FILE%
        call %executable% %db2_log_path% "context.del" %temp_file6% %props_file%
        type nul > %temp_file6%
        if %errorlevel%==0 set none_log_access=0
)

rem ----- If %none_log_access% variable is equal to 1, then finish work with return code 2
if %none_log_access%==1 (
    echo [%date%][%time%] Failure: None of logfiles is accessible or ..\bin\getdb2recs.vbs doesn't exist >> %LOG_FILE%
    echo [%date%][%time%] Processing finished [FAILURE 2] >> %LOG_FILE%
    exit /b 2
)

rem ----- Create\rewrite %props_file% file
rem ----- Obtain %USERDOMAIN% system environment variable
type nul > %props_file%
echo _domainname=%USERDOMAIN% >> %props_file%
rem DB2 9.1 update
rem checking if LDAP is enabled
if not exist %props_file%.dir (mkdir %props_file%.dir)
set DBM_CFG="%props_file%.dir\db2_cfg.txt"
set /A LDAP_ENABLED=0
if exist %DBM_CFG% ( del %DBM_CFG% )
"%db2_folder%\bin\db2cmd.exe" -c -w "db2 -r %DBM_CFG% get dbm cfg"
if %ERRORLEVEL% NEQ 0 (
    echo [%date%][%time%] Unable to call db2 and get DBM configuration.>> %LOG_FILE%
)
 
for /F "delims== tokens=1,2" %%i in ('type %DBM_CFG%') do (
    if "%%i"==" Client Userid-Password Plugin          (CLNT_PW_PLUGIN) " (
        if "%%j"==" IBMLDAPauthclient" (set /A LDAP_ENABLED=1)
    )
    if "%%i"==" Server Userid-Password Plugin        (SRVCON_PW_PLUGIN) " (
        if "%%j"==" IBMLDAPauthserver" (set /A LDAP_ENABLED=1)
    )
)

if %LDAP_ENABLED% EQU 1 ( echo _ldapenable=YES >> %props_file% ) else (echo _ldapenable=NO >> %props_file% )
    
rem end update for DB2 9.1
echo encoding1=UTF-8 >> %props_file%
echo encoding2=UTF-8 >> %props_file%
echo encoding3=UTF-8 >> %props_file%
echo encoding4=UTF-8 >> %props_file%
echo encoding5=UTF-8 >> %props_file%
echo encoding6=UTF-8 >> %props_file%

rem ----- QE0807002: Put 'CurrentTime' into propsfile
echo %LastPruneTime%>>%props_file%
rem ----- END QE0807002

rem ----- Add contents of files, which were created by getdb2recs.vbs to %props_file% file
if exist %props_file%.audit.del    type %props_file%.audit.del>>%props_file%
if exist %props_file%.checking.del type %props_file%.checking.del >> %props_file%
if exist %props_file%.secmaint.del type %props_file%.secmaint.del >> %props_file%
if exist %props_file%.sysadmin.del type %props_file%.sysadmin.del >> %props_file%
if exist %props_file%.validate.del type %props_file%.validate.del >> %props_file%
if exist %props_file%.context.del type %props_file%.context.del >> %props_file%

rem ----- Remove files
if exist %props_file%.audit.del    del /q /f %props_file%.audit.del
if exist %props_file%.checking.del del /q /f %props_file%.checking.del
if exist %props_file%.secmaint.del del /q /f %props_file%.secmaint.del
if exist %props_file%.sysadmin.del del /q /f %props_file%.sysadmin.del
if exist %props_file%.validate.del del /q /f %props_file%.validate.del
if exist %props_file%.context.del del /q /f %props_file%.context.del

rem ----- Finish work with return code 0
echo [%date%][%time%] Finish processing >> %LOG_FILE%
rem DB2 9.1 update
rmdir %PROPS_FILE%.dir /S /q
rem end update for DB2 9.1
exit /b 0
