-- Licensed Materials - Property of IBM
-- 5724-S67
-- (c) Copyright IBM Corp. 1998, 2007   All Rights Reserved.
-- US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
create view TIM_AUDIT_VIEW (ID,ITIM_EVENT_CATEGORY,ENTITY_NAME,ENTITY_DN,ENTITY_TYPE,ACTION,WORKFLOW_PROCESS_ID,INITIATOR_NAME,INITIATOR_DN,CONTAINER_NAME,CONTAINER_DN,RESULT_SUMMARY,TIMESTAMP,COMMENTS,DELEGATE_NAME,DELEGATE_DN,DELEGATE_START_TIME,DELEGATE_END_TIME,OWNER_NAME,OWNER_DN,SERVICE_NAME,SERVICE_DN,TARGET_ENTITY_NAME,TARGET_ENTITY_DN,TARGET_ENTITY_TYPE)
as
select a.ID, a.ITIM_EVENT_CATEGORY, a.ENTITY_NAME, a.ENTITY_DN, a.ENTITY_TYPE, a.ACTION, a.WORKFLOW_PROCESS_ID, a.INITIATOR_NAME, a.INITIATOR_DN, a.CONTAINER_NAME, a.CONTAINER_DN, a.RESULT_SUMMARY, a.TIMESTAMP, a.COMMENTS, b.DELEGATE_NAME, b.DELEGATE_DN, b.DELEGATE_START_TIME, b.DELEGATE_END_TIME, '', '', '', '', '', '', ''
from ENROLE.AUDIT_EVENT a, ENROLE.AUDIT_MGMT_DELEGATE b
where a.ID = b.EVENT_ID

union all

select a.ID, a.ITIM_EVENT_CATEGORY, a.ENTITY_NAME, a.ENTITY_DN, a.ENTITY_TYPE, a.ACTION, a.WORKFLOW_PROCESS_ID, a.INITIATOR_NAME, a.INITIATOR_DN, a.CONTAINER_NAME, a.CONTAINER_DN, a.RESULT_SUMMARY, a.TIMESTAMP, a.COMMENTS, '', '', '', '', c.OWNER_NAME, c.OWNER_DN,c.SERVICE_NAME, c.SERVICE_DN, '', '', ''
from ENROLE.AUDIT_EVENT a, ENROLE.AUDIT_MGMT_PROVISIONING c
where a.ID = c.EVENT_ID

union all

select a.ID, a.ITIM_EVENT_CATEGORY, a.ENTITY_NAME, a.ENTITY_DN, a.ENTITY_TYPE, a.ACTION, a.WORKFLOW_PROCESS_ID, a.INITIATOR_NAME, a.INITIATOR_DN, a.CONTAINER_NAME, a.CONTAINER_DN, a.RESULT_SUMMARY, a.TIMESTAMP, a.COMMENTS, '', '', '', '', '', '', '', '', d.TARGET_ENTITY_NAME, d.TARGET_ENTITY_DN, d.TARGET_ENTITY_TYPE
from ENROLE.AUDIT_EVENT a, ENROLE.AUDIT_MGMT_TARGET d
where a.ID = d.EVENT_ID

union all

select f.ID, f.ITIM_EVENT_CATEGORY, f.ENTITY_NAME, f.ENTITY_DN, f.ENTITY_TYPE, f.ACTION, f.WORKFLOW_PROCESS_ID, f.INITIATOR_NAME, f.INITIATOR_DN, f.CONTAINER_NAME, f.CONTAINER_DN, f.RESULT_SUMMARY, f.TIMESTAMP, f.COMMENTS, '', '', '', '', '', '', '', '', '', '', ''
from ENROLE.AUDIT_EVENT f
where f.ID not in (
select a.ID from ENROLE.AUDIT_EVENT a, ENROLE.AUDIT_MGMT_DELEGATE b where a.ID = b.EVENT_ID
union all
select a.ID from ENROLE.AUDIT_EVENT a, ENROLE.AUDIT_MGMT_PROVISIONING c where a.ID = c.EVENT_ID
union all
select a.ID from ENROLE.AUDIT_EVENT a, ENROLE.AUDIT_MGMT_TARGET d where a.ID = d.EVENT_ID )