#!/bin/ksh
# Licensed Materials - Property of IBM
# 5724-S67
# (c) Copyright IBM Corp. 1998, 2007   All Rights Reserved.
# US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

export LC_TIME="C"
TEMP_FILE=$1
LDAPHOST=$3
LDAPPORT=$4
ORGNAME=$5
USERNAME=$6
PASSWORD=$7
PROPS_FILE=$8
LOG_FILE="../log/`basename $PROPS_FILE`.log";

echo "[`date`] Processing started ..."> $LOG_FILE;

if [ "$LDAPHOST" = "" ]; 
then
  echo "[`date`] Failure: Missing LDAPHOST argument" >> $LOG_FILE;
  echo "[`date`] Processing finished [FAILURE]">> $LOG_FILE;
  exit 1;
fi
  
if [ "$LDAPPORT" = "" ]; 
then
  echo "[`date`] Failure: Missing LDAPPORT argument" >> $LOG_FILE;
  echo "[`date`] Processing finished [FAILURE]">> $LOG_FILE;
  exit 1;
fi

if [ "$ORGNAME" = "" ]; 
then
  echo "[`date`] Failure: Missing ORGNAME argument" >> $LOG_FILE;
  echo "[`date`] Processing finished [FAILURE]">> $LOG_FILE;
  exit 1;
fi

if [ "$TEMP_FILE" = "" ]; 
then
  echo "[`date`] Failure: Missing TEMP_FILE argument" >> $LOG_FILE;
  echo "[`date`] Processing finished [FAILURE]">> $LOG_FILE;
  exit 1;
fi
echo "java  -classpath "../bin/getitimgroups.jar" nl.consul.cea.gensub.itim.java.CollectITIMGroups -LDAPHost?$LDAPHOST -LDAPPort?$LDAPPORT$ -OrgName?$ORGNAME -UserName?$USERNAME -Password?$PASSWORD -Filename?$TEMP_FILE 1>> $LOG_FILE 2>&1 ";
java -Xmx256M -classpath "../bin/getitimgroups.jar" nl.consul.cea.gensub.itim.java.CollectITIMGroups -LDAPHost?$LDAPHOST -LDAPPort?$LDAPPORT -OrgName?$ORGNAME -UserName?$USERNAME -Password?$PASSWORD -Filename?$TEMP_FILE 1>> $LOG_FILE 2>&1 ;

code=$?
if [ $code = 0 ];
then
   echo "[`date`] Success: Processing finished ">>$LOG_FILE;
else
   echo "[`date`] Failure: Collect process failed Exit with code " $code>>$LOG_FILE;
   exit $code;
   exit
fi
exit 0
