REM Licensed Materials - Property of IBM
REM 5724-S67
REM (c) Copyright IBM Corp. 1998, 2007   All Rights Reserved.
REM US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@echo off
set TEMP_FILE=%1
set DSN=%2
set USER=%3
set PASSWORD=%4
set PROPS_FILE=%5
set LOG_FILE="..\log\%PROPS_FILE%.log"

echo [%date%][%time%] "Processing started ..."> %LOG_FILE%

if %TEMP_FILE% EQU "" (
  echo Failure: Missing output file argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if %DSN% EQU "" (
  echo Failure: Missing DSN argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if %USER% EQU "" (
  echo Failure: Missing username argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)
if %PROPS_FILE% EQU "" (
  echo Failure: Missing property file argument>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

"../bin/odbc-genact.exe" -preprocess="../bin/createitimview.sql" -separator=";" -useheaderline -props=%PROPS_FILE% %TEMP_FILE% "" "" "" %DSN% %USER% %PASSWORD% TIM_AUDIT_VIEW TIMESTAMP 1>> %LOG_FILE% 2>&1

if %errorlevel% EQU 1 (
  echo Failure: Collect process failed>> %LOG_FILE%
  echo [%date%][%time%] "Processing finished [FAILURE]">> %LOG_FILE%
  exit /b 1
)

echo [%date%][%time%] "Processing finished (Return code 0)" >> %LOG_FILE%
exit /b 0
