# input parameters
export LC_TIME="C"
TEMP_FILE=$TEMPFILE1
DBTYPE=$OPTION2
DBHOST=""
DBNAME=$OPTION3
DBSCHEMA=$OPTION4
DBPORT=$OPTION5
USERNAME=$OPTION6
PASSWORD=$OPTION7
PROPS_FILE=$PROPSFILE
if [ -f $PROPS_FILE ];
then
CEA_GENACT_DEBUG_LOG="../log/`basename $PROPS_FILE`.log";
else
   echo "[`date`] Failure: can't read $PROPS_FILE">>$CEA_GENACT_DEBUG_LOG;
   echo "[`date`] Processing finished (Return code 1)">>$CEA_GENACT_DEBUG_LOG;
   exit 1;
fi

echo "[`date`] Processing started ...">$CEA_GENACT_DEBUG_LOG;

DBHOST=`grep "SystemName" $PROPS_FILE | awk '{print $3}'`

if [ "$DBHOST" = "" ]; 
then
   echo "[`date`] Failure: Missing parameter SystemName from PROPS_FILE">>$CEA_GENACT_DEBUG_LOG;
   echo "[`date`] Processing finished (Return code 1)">>$CEA_GENACT_DEBUG_LOG;
   exit 1;
fi

if [ "$DBPORT" = "" ]; 
then
   echo "[`date`] Failure: Missing DBPORT argument">>$CEA_GENACT_DEBUG_LOG;
   echo "[`date`] Processing finished (Return code 1)">>$CEA_GENACT_DEBUG_LOG;
   exit 1;
fi

if [ "$DBNAME" = "" ]; 
then
   echo "[`date`] Warning: Missing DBNAME argument">>$CEA_GENACT_DEBUG_LOG;
   echo "[`date`] DBNAME set to "DB2" ">>$CEA_GENACT_DEBUG_LOG; #  check english
   DBNAME="DB2"
fi

if [ "$DBSCHEMA" = "" ]; 
then
   echo "[`date`] Failure: Missing DBSCHEMA argument">>$CEA_GENACT_DEBUG_LOG;
   echo "[`date`] Processing finished (Return code 1)">>$CEA_GENACT_DEBUG_LOG;
   exit 1;

fi

if [ "$TEMP_FILE" = "" ]; 
then
   echo "[`date`] Failure: Missing OUTPUT_FILE argument ">>$CEA_GENACT_DEBUG_LOG;
   echo "[`date`] Processing finished (Return code 1)">>$CEA_GENACT_DEBUG_LOG;
   exit 1;
fi

echo "SELECT * FROM $DBSCHEMA.AUDIT_EVENT left outer join $DBSCHEMA.AUDIT_MGMT_TARGET on $DBSCHEMA.AUDIT_EVENT.ID=$DBSCHEMA.AUDIT_MGMT_TARGET.EVENT_ID left outer join $DBSCHEMA.AUDIT_MGMT_DELEGATE on $DBSCHEMA.AUDIT_EVENT.ID=$DBSCHEMA.AUDIT_MGMT_DELEGATE.EVENT_ID left outer join $DBSCHEMA.AUDIT_MGMT_PROVISIONING on  $DBSCHEMA.AUDIT_EVENT.ID=$DBSCHEMA.AUDIT_MGMT_PROVISIONING.EVENT_ID" > $PROPSFILE.sql
echo "[`date`] Collect information from $DBHOST system, DB port $DBPORT, DBSchema $DBSCHEMA, Database: $DBNAME">>$CEA_GENACT_DEBUG_LOG;

if [ "$CEA_ITIM_SSH_MODE" = "YES" ]
then  
 #SSH
 java -Dfile.encoding=UTF-8 -classpath "../bin/jdbc-genact.jar:$CLASSPATH" eprise.audit.chunktool.generic.java.JdbcGenact -driver="$DBTYPE" -host="127.0.0.1" -port="$DBPORT" -database="$DBNAME" -username="$USERNAME" -passwd="$PASSWORD" -props="$PROPS_FILE" -outfilename="$TEMP_FILE" -sqlfilename="$PROPSFILE.sql" -tdcolumn="TIMESTAMP" -datetimeformat="yyyy-MM-dd HH:mm:ss:000 'GMT'" -useheaderline="yes"  -separator=";" -eraseoutfile="yes" -timecolumntype="string" >> $CEA_GENACT_DEBUG_LOG;
else
 #NON-SSH
 java  -Dfile.encoding=UTF-8 -classpath "../bin/jdbc-genact.jar:$CLASSPATH" eprise.audit.chunktool.generic.java.JdbcGenact -driver="$DBTYPE" -host="$DBHOST" -port="$DBPORT" -database="$DBNAME" -username="$USERNAME" -passwd="$PASSWORD" -props="$PROPS_FILE" -outfilename="$TEMP_FILE" -sqlfilename="$PROPSFILE.sql" -useheaderline="yes" -tdcolumn="TIMESTAMP" -datetimeformat="yyyy-MM-dd HH:mm:ss:000 'GMT'" -separator=";" -eraseoutfile="yes" -timecolumntype="string" >>$CEA_GENACT_DEBUG_LOG;
fi

code=$?
if [ $code = 0 ];
then
   echo "[`date`] Success: Processing finished. ">>$CEA_GENACT_DEBUG_LOG;
else
   echo "[`date`] Failure: Collect process failed.">>$CEA_GENACT_DEBUG_LOG;
   exit 1;
fi
exit 0
