LOG_FILE="../log/$PROPSFILE.log"

TRICKFILE="trick_$PROPSFILE"

# obtain hostname
HOST_NAME=`grep "SystemName" $PROPSFILE | tr "=" " " | awk '{print $2}' | col -b`

# set of  vars for sql-quary
SQL_FILE="vio.sql_$PROPSFILE"
TDCOLUMN="rundate"
IDCOLUMN=""
TABLENAME="jac_sys.violations"

# SQL-query for jac_sys.admin_log
echo "SELECT snap.rundate, pol.name as POLNAME, comp.name as COMPNAME, cl.alias, vio.* from jac_sys.violations as vio left outer join jac_sys.snapshots as snap on vio.sna_id=snap.id left outer join jac_sys.clients as cl on vio.cli_id=cl.cli_id left outer join jac_sys.policies as pol on snap.pol_id=pol.id left outer join jac_sys.compliance_sql as comp on vio.com_id=comp.id order by snap.rundate" > $SQL_FILE

echo "Starting collect from table $TABLENAME" >> $LOG_FILE

# running gettscm_shared.sh
`../bin/gettscm_shared.sh "$TEMPFILE3" "$HOST_NAME" "$OPTION2" "$OPTION3" "$OPTION4" "$OPTION5" "$SQL_FILE" "$TDCOLUMN" "$IDCOLUMN"`

code=$?
if [ $code = 0 ];
then
   echo "Collect from table $TABLENAME is finished [SUCCESS]" >> $LOG_FILE
   echo "$TABLENAME -> SUCCESS" > $TRICKFILE
else
   echo "Warning: Collect from table $TABLENAME is finished [FAILURE]" >> $LOG_FILE
   touch $TEMPFILE3
fi

# delete error.sql file
rm -f $SQL_FILE

if [ -f "$TRICKFILE" ];
then
   echo "[`date`] Processing finished. [SUCCESS] " >> $LOG_FILE
   rm -f $TRICKFILE
   exit 0
else
   echo "[`date`] Processing finished. [FAILURE] " >> $LOG_FILE
   rm -f $TRICKFILE
   exit 1
fi


