'------------------------------------------------------------------------------
' Check arguments
If (WScript.Arguments.Length <> 3) Then
  WScript.Quit(1)
End If

propsFileName = WScript.Arguments(0)
startCollectFromDate = WScript.Arguments(1)
firstSublogFileName = WScript.Arguments(2)

Call AddEntryToLog(propsFileName, "The following arguments were passed to the vbs script: " + propsFileName + " " + startCollectFromDate + " " + firstSublogFileName)

'------------------------------------------------------------------------------
Const ForReading = 1, ForWriting = 2, ForAppending = 8

Set fso = CreateObject("Scripting.FileSystemObject")
allEventsListFileName = propsFileName + ".dir\\all_events_list"

Set allEventsListFile = fso.OpenTextFile(allEventsListFileName, ForReading, False)
Set firstSublogFile = fso.OpenTextFile(firstSublogFileName, ForAppending, True)

isFoundNewEvent = False

Call AddEntryToLog(propsFileName, "Start processing .tmp files")
While allEventsListFile.AtEndOfStream = False
  tempFileName = allEventsListFile.ReadLine()
  textFileName = propsFileName + ".dir\\" + ExtractFileName(tempFileName) + ".txt"

  ' Read eacho temp file
  Set tempFile = fso.OpenTextFile(tempFileName, ForReading, False)
  Set textFile = fso.OpenTextFile(textFileName, ForAppending, True)
  Call AddEntryToLog(propsFileName, "Temp file called " + tempFileName + " is in process...")

  lineNumber = 1
  While tempFile.AtEndOfStream = False    
    line = tempFile.ReadLine()
    lineNumber = lineNumber + 1

    If isFoundNewEvent = True Then
      textFile.WriteLine(line)
      firstSublogFile.WriteLine(line)
    Else
      Set regEx = New RegExp
      regEx.Pattern = "^" + startCollectFromDate + ".*"

      If regEx.Execute(line).Count > 0 Then
        Call AddEntryToLog(propsFileName, "Found pattern in the following line: " + line)
      
        isFoundNewEvent = True
        textFile.WriteLine(line)
        firstSublogFile.WriteLine(line)
      End If    
    End If

  Wend

  If isFoundNewEvent = True Then
    Call AddToListOfFilesToBeArchived(propsFileName, textFileName)
  End If

  textFile.Close()
  tempFile.Close()
Wend

firstSublogFile.Close()
allEventsListFile.Close()

Set propsFile = fso.OpenTextFile(propsFileName, ForAppending, True)
propsFile.WriteLine(lineNumber)
propsFile.Close()
WScript.Quit(0)

'------------------------------------------------------------------------------
' Returns only file name without path or extension
Function ExtractFileName(filePath)
  Set fso = CreateObject("Scripting.FileSystemObject")
  fileName = fso.GetFileName(filePath)
  Dim regEx
  Set regEx = New RegExp
  regEx.Pattern = "^(.+)\.(.+?)$"

  Set matches = regEx.Execute(fileName)
  For Each match in matches
      ExtractFileName = match.Submatches(0)
      Exit Function
  Next

  ExtractFileName = fileName
End Function

'------------------------------------------------------------------------------
' Save trace file name to the list of files, that will be archived
Function AddToListOfFilesToBeArchived(propsFileName, textFileName)
  Const ForReading = 1, ForWriting = 2, ForAppending = 8
  Set fso = CreateObject("Scripting.FileSystemObject")
  
  listOfFilesToBeArchivedFileName = propsFileName + ".dir\\list"
  Set listOfFilesToBeArchivedFile = fso.OpenTextFile(listOfFilesToBeArchivedFileName, ForAppending, True)

  traceFileFullName = GetTraceFileFullNameByTextFileName(propsFileName, textFileName)
  listOfFilesToBeArchivedFile.WriteLine("""" + traceFileFullName + """")


  listOfFilesToBeArchivedFile.Close()
End Function

'------------------------------------------------------------------------------
' Returns corresponding full trace file name using the name of the text file
Function GetTraceFileFullNameByTextFileName(propsFileName, textFileName)
  Const ForReading = 1, ForWriting = 2, ForAppending = 8
  Set fso = CreateObject("Scripting.FileSystemObject")
  
  listingFileName = propsFileName + ".dir\listing." + propsFileName
  Set listingFile = fso.OpenTextFile(listingFileName, ForReading, False)
  
  While listingFile.AtEndOfStream = False
    traceFilePath = listingFile.ReadLine()
    
    If ExtractFileName(traceFilePath) = ExtractFileName(textFileName) Then
      GetTraceFileFullNameByTextFileName = traceFilePath
      Exit Function
    End If
  Wend  

  listingFile.Close()
End Function

'------------------------------------------------------------------------------
Function AddEntryToLog(propsFileName, message)  
  Const ForReading = 1, ForWriting = 2, ForAppending = 8
  Set fso = CreateObject("Scripting.FileSystemObject")
  
  logFileName = "..\log\" + propsFileName + ".log"
  Set logFile = fso.OpenTextFile(logFileName, ForAppending, True)

  currentDate = Now()
  currentTimeFormated = Mid(currentDate, 1, Len(currentDate))
    
  logFile.WriteLine(currentTimeFormated + " " + message)
  
  logFile.Close()
End Function
'------------------------------------------------------------------------------
