REM Licensed Materials - Property of IBM
REM 5724-S67
REM (c) Copyright IBM Corp. 1998, 2008   All Rights Reserved.
REM US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
set TEMP_FILE1=%1
set TEMP_FILE2=%2
set CLEANUP=%3
set TRACE_PATH=%4
set INSTANCE=%5
set USER_NAME=%6
set PASSWORD=%7
for %%A in (%*) do set PROPS_FILE=%%A

type nul > ..\log\%PROPS_FILE%.log
type nul > %TEMP_FILE1%


if "%TEMP_FILE1%" EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  goto EXIT_ERROR
)           
if "%TEMP_FILE2%" EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  goto EXIT_ERROR
)
if %TRACE_PATH% EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  goto EXIT_ERROR
)
if "%USER_NAME%" EQU "" (
  @echo %date% %time% "FAIL: Missing argument" >> ..\log\%PROPS_FILE%.log
  goto EXIT_ERROR
)

@echo %date% %time% "Processing started" >> ..\log\%PROPS_FILE%.log
mkdir %PROPS_FILE%.dir

rem -------------------------------------------------------------------------------------------------------------------
rem  Creates two lists of trace files: with ascending and  descending  order by date of creating, files are matched without prefix
dir /OD /A-D /B /S %TRACE_PATH% | findstr "[0-9][0-9]*_*[0-9]*.trc" > %PROPS_FILE%.dir\listing.%PROPS_FILE%
dir /O-D /A-D /B /S %TRACE_PATH% | findstr "[0-9][0-9]*_*[0-9]*.trc" > %PROPS_FILE%.dir\reverslist.%PROPS_FILE%
@echo %date% %time% "Created listing of available Audit traces" >> ..\log\%PROPS_FILE%.log

rem check for first collect  and assign  variables for secondary collecting
if EXIST %PROPS_FILE% (
  for /F "delims=," %%I in ('findstr /V "[0-9][0-9]*_*[0-9]*.trc" %PROPS_FILE%') DO (set LINE_NUM=%%I)
  for /F "delims=," %%I in ('findstr "[0-9][0-9]*_*[0-9]*.trc" %PROPS_FILE%') DO (set PREV_FILE=%%I)
  goto NONFC
)else (
  goto FC
)
rem -------------------------------------------------------------------------------------------------------------------
:NONFC
rem check: if listing is not empty
for %%I in (%PROPS_FILE%.dir\listing.%PROPS_FILE%) DO (set FILE_SIZE=%%~zI)
if "%FILE_SIZE%" EQU "0" (
    @echo %date% %time% "WARNING: There are no trace files in the pointed directory: %TRACE_PATH%" >> ..\log\%PROPS_FILE%.log
    type nul > %TEMP_FILE2%
    goto EXIT_OK
) else (
rem Check connection with server
    for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO ( 
        if "%%~zI" NEQ "0" (
            bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', 1)" QUERYOUT "%PROPS_FILE%.dir\tmp.txt" -U%USER_NAME% -P%PASSWORD% -S%INSTANCE% -f../bin/format.fmt -F 1 -L 2
            goto NEXT1
        )
    )
)
rem if all trc files are empty
@echo %date% %time% "WARNING: Could not check connection to MS SQL Server: traces are empty" >> ..\log\%PROPS_FILE%.log
type nul > %TEMP_FILE2%
goto EXIT_OK

:NEXT1
if errorlevel 1 (
  @echo %date% %time% "ERROR: Could not connect to MS SQL Server (Return code 1)" >> ..\log\%PROPS_FILE%.log
  GOTO EXIT_ERROR
)
rem End check

rem create temporary list for deleting and packing of files, set old LAST_LINE value
@echo %date% %time% "Properties file contents: %PREV_FILE% %LINE_NUM% " >> ..\log\%PROPS_FILE%.log
type nul>%PROPS_FILE%.dir\list
set /a OLD=%LINE_NUM%-1

rem check if exist trace file that is equal to prev_file
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
    if "%PREV_FILE%" EQU "%%I" (
        if "%%~zI" NEQ "0" (
            goto EXIST_TRC
        )
    )
)
rem if there is no trc that is equal to prev_file-- take file that is greather than prev_file and check it for its size
@echo %date% %time% "WARNING: Previous last handled trace file was deleted" >> ..\log\%PROPS_FILE%.log
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
    if "%PREV_FILE%" LSS "%%I" ( 
        if "%%~zI" NEQ "0" (
            set PREV_FILE=%%I
            set /a LINE_NUM=1
            set /a OLD=0
            goto EXIST_TRC
        )
    )
)
rem if there are no any trc greather than prev_file
@echo %date% %time% "WARNING: Could not find new non empty traces" >> ..\log\%PROPS_FILE%.log
type nul > %TEMP_FILE2%
goto EXIT_OK

:EXIST_TRC
rem obtain records from prev_file: take file that is equal to prev_file and copy records from all files below in listing
set /a TRCCOPY=0
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO (
    call :ALLOW_COPY
    if errorlevel 1 (
        if "%%zI" NEQ "0" (
            call bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', 1)" QUERYOUT "%PROPS_FILE%.dir\%%~nI.txt" -U%USER_NAME% -P%PASSWORD% -S%INSTANCE% -f../bin/format.fmt>%PROPS_FILE%.dir\bcpout.txt
            if errorlevel 1 (
                @echo %date% %time% "WARNING: File %%I was corrupted" >> ..\log\%PROPS_FILE%.log
            )
            echo "%%I">>%PROPS_FILE%.dir\list
            @echo %date% %time% "Collected data from Audit trace %%~nI" >> ..\log\%PROPS_FILE%.log
            type "%PROPS_FILE%.dir\%%~nI.txt" >> %TEMP_FILE1%
            del /Q %PROPS_FILE%.dir\%%~nI.txt
            set /a OLD=0
            set LAST_TRACE_FILE=%%I
        )
    )
    if "%PREV_FILE%" EQU "%%I" (
        call bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', 1)" QUERYOUT "%TEMP_FILE1%" -U%USER_NAME% -P%PASSWORD% -S%INSTANCE% -f../bin/format.fmt -F%LINE_NUM%>%PROPS_FILE%.dir\bcpout.txt
        if errorlevel 1 (
            @echo %date% %time% "WARNING: File %%I was corrupted" >> ..\log\%PROPS_FILE%.log
        )
rem create a list of files need to be archived and deleted
        echo "%%I">>%PROPS_FILE%.dir\list
        set LAST_TRACE_FILE=%%I
        set /a TRCCOPY=1
        @echo %date% %time% "Collected data from Audit trace %%~nI" >> ..\log\%PROPS_FILE%.log
        
    ) 
)

rem take number of copied rows from bcpout file
set /a LINE_NUM=0
for /F "tokens=1" %%I IN ('findstr /C:"rows copied" %PROPS_FILE%.dir\bcpout.txt') DO (set LINE_NUM=%%I) 

rem check for LINE_NUM: line_num must be different from 0
if "%LINE_NUM%" EQU "0" (
    @echo %date% %time% "WARNING: There are no new events or trace files were corrupted" >> ..\log\%PROPS_FILE%.log
    type nul > %TEMP_FILE2%
    GOTO EXIT_OK
)

set /a LINE_NUM=LINE_NUM+OLD+1
echo %LAST_TRACE_FILE%>%PROPS_FILE%
echo "%LINE_NUM%">>%PROPS_FILE%
goto TAR:


rem -------------------------------------------------------------------------------------------------------------------
:FC
rem check if listing file is not empty
for %%I in (%PROPS_FILE%.dir\listing.%PROPS_FILE%) DO (set FILE_SIZE=%%~zI)
 
if "%FILE_SIZE%" EQU "0" (
    echo 000000000000.trc>%PROPS_FILE%
    echo "1">>%PROPS_FILE%
    @echo %date% %time% "WARNING: There are no trace files in the pointed directory: %TRACE_PATH% " >> ..\log\%PROPS_FILE%.log
    type nul > %TEMP_FILE2%
    goto EXIT_OK
) else (
rem check connection with MS SQL server
    for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\listing.%PROPS_FILE%') DO ( 
        if "%%~zI" NEQ "0" (
        bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', 1)" QUERYOUT "%PROPS_FILE%.dir\tmp.txt" -U%USER_NAME% -P%PASSWORD% -S%INSTANCE% -f../bin/format.fmt -F 1 -L 2
        goto NEXT2
        )
    )
)

@echo %date% %time% "ERROR: Could not check connection to MS SQL Server: there are no non empty traces in the pointed directory %TRACE_PATH%" >> ..\log\%PROPS_FILE%.log
goto EXIT_ERROR

:NEXT2
if errorlevel 1 (
    @echo %date% %time% "ERROR: Could not connect to MS SQL Server (Return code 1)" >> ..\log\%PROPS_FILE%.log
    GOTO EXIT_ERROR
)
rem End check
type nul>%PROPS_FILE%.dir\list
rem take the latest trace file from listing and if its size is not equal to NULL copy log records to TEMP1
for /F "delims=," %%I IN ('type .\%PROPS_FILE%.dir\reverslist.%PROPS_FILE%') DO ( 
    if "%%~zI" NEQ "0" (
        call bcp.exe "SELECT StartTime, EventClass, EventSubClass, REPLACE( REPLACE( REPLACE( REPLACE( REPLACE( CONVERT( NVARCHAR(1000), TextData), '          ', ' '), '     ', ' '), CHAR(10), ' '), CHAR(9), ' '),CHAR(13), ' '), LoginName, Success, HostName, ServerName, DatabaseName, ObjectName, TargetLoginName, RoleName FROM ::fn_trace_gettable( '%%I', 1)" QUERYOUT "%TEMP_FILE1%" -U%USER_NAME% -P%PASSWORD% -S%INSTANCE% -f../bin/format.fmt>%PROPS_FILE%.dir\bcpout.txt
        echo "%%I">>%PROPS_FILE%.dir\list
        set LAST_TRACE_FILE=%%I
        @echo %date% %time% "Collected data from Audit trace %%~nI" >> ..\log\%PROPS_FILE%.log
        goto NEXT3
   ) else (
        @echo %date% %time% "WARNING: File %%I is empty" >> ..\log\%PROPS_FILE%.log
   )
)

@echo %date% %time% "WARNING: Could not find non empty traces" >> ..\log\%PROPS_FILE%.log
type nul > %TEMP_FILE2%
goto EXIT_OK

:NEXT3  
for /F "tokens=1" %%I IN ('findstr /C:"rows copied" %PROPS_FILE%.dir\bcpout.txt') DO (set LINE_NUM=%%I) 
rem check for LINE_NUM: line_num must be different from 0
if "%LINE_NUM%" EQU "" (
    @echo %date% %time% "WARNING: There are no events or trace file was corrupted" >> ..\log\%PROPS_FILE%.log
    set /a LINE_NUM=0
)

echo %LAST_TRACE_FILE%>%PROPS_FILE%
set /a LINE_NUM=LINE_NUM+1
echo "%LINE_NUM%">>%PROPS_FILE%
goto TAR:

rem -------------------------------------------------------------------------------------------------------------------
:TAR
rem Make an archive with trc files
for /F "delims=," %%I in ('type %PROPS_FILE%.dir\list') do (
  call :ARCHIVE %%I
)
@echo %date% %time% "Original logs archive created" >> ..\log\%PROPS_FILE%.log
goto T:

rem -------------------------------------------------------------------------------------------------------------------
:T
if "%CLEANUP%" EQU "yes" (
  @echo %date% %time% "Cleanup requested. Cleanning..." >> ..\log\%PROPS_FILE%.log
   for /F "delims=," %%I in ('type .\%PROPS_FILE%.dir\list') DO (
      if %%I NEQ "%LAST_TRACE_FILE%" (
      del /Q %%I
      @echo %date% %time% "Deleting file %%I"... >> ..\log\%PROPS_FILE%.log
    )
  )
  @echo %date% %time% "Cleanup finished" >> ..\log\%PROPS_FILE%.log
)
goto EXIT_OK
rem -------------------------------------------------------------------------------------------------------------------
:EXIT_ERROR
rmdir /S /Q %PROPS_FILE%.dir
del /Q %TEMP_FILE1%
@echo %date% %time% "Processing finished (Return code 1)" >> ..\log\%PROPS_FILE%.log
exit /b 1

:EXIT_OK
rmdir /S /Q %PROPS_FILE%.dir
@echo %date% %time% "Processing finished (Return code 0)" >> ..\log\%PROPS_FILE%.log
exit /b 0

:ARCHIVE
set CURRENT_FILE=%~1
if EXIST %TEMP_FILE2% (
    ..\bin\bsdtar.exe -rf %TEMP_FILE2% "%CURRENT_FILE%"
  ) else (
    ..\bin\bsdtar.exe -cf %TEMP_FILE2% "%CURRENT_FILE%"
  )
goto :EOF

:ALLOW_COPY
if "%TRCCOPY%" EQU "1" (exit /b 1) else (exit /b 0)
goto :EOF

