@echo off

set TEMP_FILE=%1
set GROUP_FILE=%2
set DSN_NAME=%3
set USER=%4
set PASS=%5
for %%A in (%*) do set PROPS_FILE=%%A

set LOG_FILE="..\log\%PROPS_FILE%.log"

if not exist ..\log mkdir ..\log
type nul > %LOG_FILE%
echo [%date%][%time%] Processing started ...> %LOG_FILE%

if %TEMP_FILE% EQU "" (
    echo [%date%][%time%] Failure: Missing argument TEMP_FILE >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

if %GROUP_FILE% EQU "" (
    echo [%date%][%time%] Failure: Missing argument GROUP_FILE >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

if %DSN_NAME% EQU "" (
    echo [%date%][%time%] Failure: Missing argument DSN_NAME >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

if %USER% EQU "" (
    echo [%date%][%time%] Failure: Missing argument USER >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

if %PROPS_FILE% EQU "" (
    echo [%date%][%time%] Failure: Missing argument PROPS_FILE >> %LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
)

del %TEMP_FILE% %TEMP_FILE%_pre >>nul 2>&1
del sql_%TEMP_FILE% >>nul 2>&1

echo SELECT wlur.role_name, wlur.user_name FROM applsys.wf_local_user_roles wlur >>sql_%TEMP_FILE%

setlocal EnableDelayedExpansion

call ..\bin\odbc-genact.exe -separator=; -fromquery1 -props=%PROPS_FILE% %TEMP_FILE%_pre "" "" "" %DSN_NAME% %USER% %PASS% sql_%TEMP_FILE% - 1>>%LOG_FILE% 2>&1

if %errorlevel% NEQ 0 (
    if exist %TEMP_FILE% del %TEMP_FILE% 
	del sql_%TEMP_FILE% %TEMP_FILE%_pre >>nul 2>&1
    echo [%date%][%time%] Collect of UIS records failed. [FAILURE] >>%LOG_FILE%
    echo [%date%][%time%] Processing finished. [FAILURE]>> %LOG_FILE%
    exit /b 1
) 
del sql_%TEMP_FILE% >>nul 2>&1
if not exist %TEMP_FILE%_pre (
    echo [%date%][%time%] Warning: No recodrs were received. >> %LOG_FILE%
	del %TEMP_FILE%_pre >>nul 2>&1
    echo [%date%][%time%] Processing finished. [SUCCESS]>> %LOG_FILE%
    exit /b 0
)

setlocal
echo [SourceGroup]>%TEMP_FILE%
for /f "tokens=2,3 delims=;" %%b in ('type "%TEMP_FILE%_pre"') do (
	echo "%%b">>%TEMP_FILE%
	echo {>> %TEMP_FILE%
	echo    match logonname "%%c">> %TEMP_FILE%
	echo }>> %TEMP_FILE%
)

if exist %PROPS_FILE% del %PROPS_FILE%

setlocal disabledelayedexpansion
endlocal

del %TEMP_FILE%_pre >>nul 2>&1

echo [%date%][%time%] Processing finished. [SUCCESS] >> %LOG_FILE%
exit /b 0